CREATE OR REPLACE PROCEDURE GERA_LOTE_CTB(
    P_CDEMPRESA      IN EMPRESA.CDEMPRESA%TYPE,
    P_NRSEQMAPAPU    IN MAPAAPUFRETE.NRSEQMAPAPU%TYPE,
    P_NRINSJURTRAN   IN MAPAAPUFRETE.NRINSJURTRAN%TYPE,
    P_CDFILIAL       IN FILIAL.CDFILIAL%TYPE,
    P_TPLOTE         IN VARCHAR2)

AS
V_CONTCTBLCRED   CONTCTBL.CDCONTCTBL%TYPE;
V_CONCTBTLDEBI   CONTCTBL.CDCONTCTBL%TYPE;
V_CDEMPRESA      EMPRESA.CDEMPRESA%TYPE;
V_CDLOTE         CAPALOTE.CDLOTE%TYPE;
V_DTINI          CAPALOTE.DTINICLOTE%TYPE;
V_DTFIN          CAPALOTE.DTFINALOTE%TYPE;
V_CDCONTCTBL     CONTCTBL.CDCONTCTBL%TYPE;
V_CDCONTCTBLP    CONTCTBL.CDCONTCTBL%TYPE;
V_STCONTDIFE     CONTCTBL.CDCONTCTBL%TYPE;
V_CDHISTPADR     HISTPADR.CDHISTPADR%TYPE;
V_NRLANCLOTE     LANCLOTE.NRLANCLOTE%TYPE;
V_DSHISTPADR     VARCHAR2(1000);
V_CONTCCUS       VARCHAR2(01);
V_IDCONTCOME     VARCHAR2(01);
V_CDCENTCUST     VARCHAR2(04);
BEGIN

   IF P_TPLOTE = 'FRETE' THEN
      BEGIN
         SELECT MAX(NF.CDEMPRESA), MAX(MP.DTINICIAL), MAX(MP.DTFINAL)
           INTO V_CDEMPRESA, V_DTINI, V_DTFIN
           FROM MAPAAPUFRETE MP,  MAPAFRETENF M, NOTAFISCAL NF
          WHERE MP.NRSEQMAPAPU  = M.NRSEQMAPAPU
            AND M.CDFILIAL      = NF.CDFILIAL
            AND M.NRLANCTONF    = NF.NRLANCTONF
            AND MP.NRINSJURTRAN = P_NRINSJURTRAN
            AND MP.NRSEQMAPAPU  = P_NRSEQMAPAPU;
      EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDEMPRESA := NULL;
         V_DTINI := NULL;
         V_DTFIN := NULL;
      END;
      V_CDLOTE := SUBSTR(P_TPLOTE,1,2)||SUBSTR(P_NRINSJURTRAN,1,8)||P_NRSEQMAPAPU;

      INSERT INTO CAPALOTE
            (CDEMPRESA, CDLOTE, DTINICLOTE, DTFINALOTE,IDTPMOVLOTE,IDLOTE, DTULTATU)
          VALUES
            (V_CDEMPRESA, V_CDLOTE, V_DTINI, V_DTFIN, NULL, 'D', SYSDATE);

      FOR C_NF_MP IN (SELECT DISTINCT NF.CDFILIAL, NF.CDINSCESTA, NF.NRLANCTONF, NF.NRINSJURTRAN,
                             NF.CDTIPOOPER, NF.IDENTRSAIDOP, NF.CDFILIEMIT,  NF.CDFILIRECE, ROUND(MP.VRFRETE,2) AS VRFRETE,
                             ROUND(MP.VRICMS,2) AS VRICMS,
                             NF.DTEMISSAO, NF.NRNOTAFISC, NF.CDCLIENTE
                        FROM MAPAFRETENF MP, NOTAFISCAL NF
                       WHERE MP.CDFILIAL     = NF.CDFILIAL
                         AND MP.NRLANCTONF   = NF.NRLANCTONF
                         AND MP.NRSEQMAPAPU  = P_NRSEQMAPAPU
                         AND NF.CDEMPRESA    = V_CDEMPRESA
                         AND MP.NRINSJURTRAN = P_NRINSJURTRAN)LOOP


      /*BUSCA A CONTA CONTBIL DOS PARMETROS DE EXPEDIO*/
      BEGIN
        SELECT CDCONTCTBLCRED, CDCONTCTBLDEBI, CDHISTPADR
          INTO V_CONTCTBLCRED, V_CONCTBTLDEBI, V_CDHISTPADR
          FROM PAREXPEDICAO
         WHERE CDFILIAL = P_CDFILIAL;
      EXCEPTION
           WHEN NO_DATA_FOUND THEN
          V_CONTCTBLCRED := NULL;
          V_CONCTBTLDEBI := NULL;
          V_CDHISTPADR   := NULL;
      END;

      BEGIN
         SELECT IDCONTGERE, IDCONTCOME
           INTO V_CONTCCUS, V_IDCONTCOME
           FROM CONTOPECTBL
          WHERE CDEMPRESA = V_CDEMPRESA;
      EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CONTCCUS   := NULL;
         V_IDCONTCOME := NULL;
      END;


         /*MONTA O HISTORICO DO LANAMENTO*/
         MONTA_HISTORICO(C_NF_MP.CDFILIEMIT, C_NF_MP.CDINSCESTA ,V_CDHISTPADR,C_NF_MP.NRNOTAFISC,C_NF_MP.DTEMISSAO,'00', '', V_DSHISTPADR);
         /*RETORNA SEQUENCIAL DA LANCLOTE PARA O  LOTE CONTBIL*/
         GERA_LOTECONTABIL(V_CDEMPRESA,'01',C_NF_MP.CDFILIEMIT,'',V_DTFIN,'','',V_CDLOTE,V_NRLANCLOTE,V_CDLOTE);
         IF C_NF_MP.VRFRETE > 0 THEN
            /*CREDITA CONTA DE CREDITO*/
            NOVA_PARTIDA(V_CDEMPRESA,V_CDLOTE,V_DTFIN ,V_NRLANCLOTE,  V_CONTCTBLCRED, V_CDHISTPADR,
                         V_DSHISTPADR, C_NF_MP.VRFRETE, '', '', '', C_NF_MP.NRNOTAFISC, 'N');
            /*DEBITA CONTA DE DBITO*/
            NOVA_PARTIDA(V_CDEMPRESA,V_CDLOTE,V_DTFIN ,V_NRLANCLOTE,  V_CONCTBTLDEBI, V_CDHISTPADR,
                         V_DSHISTPADR, C_NF_MP.VRFRETE*-1, '', '', '', C_NF_MP.NRNOTAFISC, 'N');

                  /*VERIFICA O CENTRO DE CUSTO CADASTRADO*/
            BEGIN
               SELECT NVL(F.CDCENTCUST, E.CDCENTCUST) AS CDCENTCUST
                 INTO V_CDCENTCUST
                 FROM FILIAL F, EMPRESA E
                WHERE F.CDFILIAL  = C_NF_MP.CDFILIRECE
                  AND E.CDEMPRESA = V_CDEMPRESA;
            EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                  V_CDCENTCUST := NULL;
            END;
            /*VERIFICA SE A CONTA CONTBIL  OFICIAL/GERENCIAL E GERENCIAL*/
            BEGIN
             SELECT IDCONTCCUS
               INTO V_CONTCCUS
               FROM CONTCTBL
              WHERE CDCONTCTBL = V_CONCTBTLDEBI;
            EXCEPTION
              WHEN NO_DATA_FOUND THEN
                V_CONTCCUS := NULL;
            END;

            IF V_CDCENTCUST IS NOT NULL THEN
               IF V_CONTCCUS <> 'O' THEN
                RATEIO_PARTIDA(V_CDEMPRESA, V_CDLOTE, V_DTFIN, V_NRLANCLOTE, C_NF_MP.CDFILIRECE,
                               V_CDCENTCUST, nvl(C_NF_MP.VRFRETE*-1,0));
               END IF;
            END IF;

         END IF;
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_LOTE_CTB','6.05.xxx'); END;
/

